/*global define,window*/
define([
    'testsuite/qunit',
    'jquery',
    'ep',
    'testsuite/qunit-fixture!./shippouninstallapp-test',
    'de_epages/shippo/ui/shippouninstallapp'
], function(QUnit, $, ep, fixture, shippouninstallapp) {

    'use strict';
    QUnit.module('de_epages/shippo/ui/shippouninstallapp', {
        setup: fixture.init,
        teardown: fixture.destroy
    });
//
    QUnit.test('Check if the behaviour of uninstall app is as expected ', 2, function() {

        ep.ajax = function(o) {
            var result = $.Deferred();

            result.resolve({
                "status": "ok",
                "message": "",
            });

            return result;
        };

        // Mocking the window to avoid the reload
        this.mockWindow = {
            location: {
                reload: function() {
                    ok(true, "This mock function should be called");
                }
            }
        };
        
        var UninstallAppButton = $('#ShippoCanConnect');
        shippouninstallapp( UninstallAppButton, "12345", this.mockWindow );

        UninstallAppButton.trigger('click');
        $('#YesId').trigger('click');

        QUnit.strictEqual(
                $("#Response").html(),
                'OK',
                'Check that the value of the dialog is the expected for a properly execution. We are waiting for the word OK at the dialog'
        );
    });
});