/*global define,window*/

define([
    'testsuite/qunit',
    'jquery',
    'de_epages/presentation/ui/history',

    '$ready!'
], function (QUnit, $, de_epages) {

    QUnit.module("de_epages/presentation/ui/history", {
        setup: function () {
            $('<ul id="historyBox" />').appendTo('#qunit-fixture');
        }
    });

    QUnit.asyncTest("de_epages/presentation/ui/history", function () {
        $.ajax = function (o) {
            var result = $.Deferred();

            if (o.data && o.data.ViewAction === 'JSONObjectExists') {
                result.resolveWith(o.context || result, [{"ObjectExists" : 0}]);
            }
            return result;
        };

        var historyHandle = de_epages.presentation.history;

        historyHandle.remove();

        // add current
        historyHandle.add();

        // add additional
        historyHandle.add({
            title: 'history entry',
            objectId: 6789,
            viewAction: 'MBO-ViewHistory'
        });


        $('#historyBox')
            .presentationUiHistory();

        QUnit.equal(
            $("#historyBox > li").length,
            2,
            '$("#historyBox > li").length'
        );

        // add additional
        historyHandle.add({
            objectId: 16789,
            viewAction: 'MBO-ViewDummy'
        });

        historyHandle.add({
            objectId: 16789,
            viewAction: 'MBO-ViewDummy'
        });

        $('#historyBox')
            .presentationUiHistory();

        QUnit.equal(
            $("#historyBox > li").length,
            3,
            '$("#historyBox > li").length'
        );

        $("#historyBox > li > a:first").trigger('click');

        QUnit.equal(
            $('.ep-uiDialog-alert').length,
            1,
            'Check warning dialog'
        );

        $('.ep-uiDialog-alert').uiDialog('close');
        $('.addToFavorite').trigger('click');
        $("#historyBox > li > a:last").trigger('click');

        QUnit.equal(
            $("#historyBox > li").length,
            1,
            'Clear history'
        );

        $('#historyBox').presentationUiHistory('destroy');

        QUnit.equal(
            $('#historyBox').hasClass('de_epages-presentationUiHistory'),
            0,
            'remove history widget'
        );

        QUnit.start();
    });
});